
// Description                              /*{{{*/
// $Id: dudf.h,v 1.2 2008/01/29 13:04:48 prrt Exp $
/* ######################################################################
   
   DUDF - Distribution Upgradeability Description Format
   
   This class has a single global instance. 
   It is responsible for generating the DUDF file as defined in MANCOOSI 
   project.
   DUDF contais one problem instance.
   
   ##################################################################### */
                                    /*}}}*/
#ifndef PKGLIB_DUDF_H
#define PKGLIB_DUDF_H

#include <string>
#include <vector>
#include <iostream>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>

#include <jsoncpp/json.h>
#include <rpm/header.h>
#include <sys/types.h>
#include <libxml/parser.h>
#include <libxml/tree.h>

//#define MAXDUDFPKG 20;
#define MAXBUFFER 16 * 1024
#define DUDF_VERSION "2.0"

using std::string;
using std::vector;
using namespace std;

class GlobalDudf
{
    bool generateUUID(string& uuid);
    bool isEssentialPackage(const string& packageName);
    bool CreateDudfDocument(string Request, string ResultStatus);
    bool TryCreateDudfDocument(string Request, string ResultStatus);
        string dumpRPMDb();

    bool addUrpmiSkipList(xmlDocPtr doc, xmlNodePtr node);
    bool addUrpmiInstList(xmlDocPtr doc, xmlNodePtr node);
    bool addUrpmiPreferList(xmlDocPtr doc, xmlNodePtr node);
    bool addUrpmiPreferVendorList(xmlDocPtr doc, xmlNodePtr node);

    bool addUrpmiFile(xmlDocPtr doc, xmlNodePtr node, string nodeName, string filename);

    struct DudfPackageInfo
    {
            string Name;
            string VerRel;
            string Status;
            string DepBrokenName;
            string DepConstrain;
            string DepConstVersion;
            string DepCandidate;

    };

    vector<DudfPackageInfo> *PtrPkgInfo;
    //RPMPackageData *rpmdata;

    struct DudfInfo
   {
      string Distribution;
      string InstallerName, InstallerVersion;
      string MetaInstallerName, MetaInstallerVersion;
      string InstallerDbFilename;
      // DudfPackageList SetDudfPackageLists[MAXDUDFPKG];
      
   };

    string FilenameFingerprint, Timestamp;
    string DudfErrorMsg;

    DudfInfo DudfInfoElement;

    /* The DUDF XML tree */
    xmlDocPtr dudfDoc;
   
      public:

   // CNC:2003-02-24 - See above.
   //void SetDist(string InstallerName, string MetaInstallerVersion );
      
   // Usefull routine to dump to file
   bool DumpToFile(string CmdL,string ResultStatus);
   string CreateDudf(string request, string ResultStatus);
   string GetFilenameFingerprint();
   bool SetDistro();
   bool PackageDb(string &pkgstatus);
   bool PackageDbJson(string &pkgstatus);
   bool PackageUniverse(vector<string> *PtrListFiles);
   void AddMsgError(string MsgErrorPart);
   void PackagesInfo(string PkgName, string PkgVerRel,string PkgStatus,string PkdDepBrokenName, 
           string PkgDepConstrain,string PkgDepConstVersion,string PkgDepCandidate);
   
   
   GlobalDudf();
   ~GlobalDudf();
};
 

GlobalDudf *_GetDudfObj();
#define _dudf _GetDudfObj()
string SafeGetCWD();
Json::Value getTagArray(Header, rpmTag);
Json::Value getTagInteger(Header, rpmTag);
Json::Value getTagString(Header, rpmTag);
bool isDepFlag(uint64_t);

struct StringComparator {
    bool operator()(const char* lhs, const char* rhs) const {
        return strcmp(lhs, rhs);
    }
};

Json::Value getTagRequires(Header, rpmTag, rpmTag, rpmTag);
void getOfficialRepos(vector<string> &repos);
const char* md5OfFile(string);
#endif

// vim:sts=3:sw=3
